/*
 * engine:      hsqldb
 * version:     0.0.1
 * description: initial database structure
 */

/*
 * temporary raw data from xml, and upload journal
 */
create table upload_journal
(
    id         bigint                              not null generated by default as identity (start with 1, increment by 1),
    filename   varchar(100)                        not null,
    created_at timestamp default current_timestamp not null,
    updated_at timestamp default current_timestamp not null,
    status     varchar(100)                        not null,
    primary key (id)
);

create table upload_customer
(
    id          bigint       not null generated by default as identity (start with 1, increment by 1),
    journal_id  bigint       not null references upload_journal (id),
    inn         varchar(11)  not null unique,
    first_name  varchar(100) not null,
    last_name   varchar(100) not null,
    middle_name varchar(100) not null,
    primary key (id)
);
create index upload_customer_journal_id on upload_customer (journal_id);

create table upload_transaction
(
    id          bigint         not null generated by default as identity (start with 1, increment by 1),
    journal_id  bigint         not null references upload_journal (id),
    place       varchar(100)   not null,
    amount      numeric(18, 2) not null,
    currency    varchar(3)     not null,
    card_no     varchar(16)    not null,
    customer_id bigint         not null references upload_customer (id),
    primary key (id)
);
create index upload_tr_journal_id on upload_transaction (journal_id);
create index upload_tr_customer_id on upload_transaction (customer_id);

create table upload_error
(
    id                bigint                             not null generated by default as identity (start with 1, increment by 1),
    journal_id        bigint                             not null references upload_journal (id),
    created_at        datetime default current_timestamp not null,
    exception_class   varchar(255),
    exception_message varchar(255),
    stacktrace        longvarchar,
    primary key (id)
);
create index upload_error_journal_id on upload_error (journal_id);
